<?php

class TiposTransportesController extends Controller
{
    private $tipoTransporteModel;

    public function __construct()
    {
        if (!Sessao::estaLogado()) {
            URL::redirecionar('usuarios/login');
        }
        $this->tipoTransporteModel = $this->model('TipoTransporte');
    }

    public function index()
    {
        $dados = [
            'tipos_transportes' => $this->tipoTransporteModel->lerTiposTransportes()
        ];
        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/tipos_transportes/index.php',
            'dados'    => $dados
        ]);
    }

    public function cadastrar()
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST') {
            $formulario = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);

            $dados = [
                'descricao'  => strtoupper($formulario['descricao'] ?? ''),
                'id_usuario' => $_SESSION['id_usuario'] ?? 1
            ];

            if ($this->tipoTransporteModel->armazenar($dados)) {
                Sessao::mensagem('tipo_transporte', 'Tipo de transporte cadastrado com sucesso!');
                URL::redirecionar('tipos_transportes');
            } else {
                Sessao::mensagem('tipo_transporte', 'Erro ao cadastrar tipo de transporte', 'alert alert-danger');
            }
        }

        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/tipos_transportes/cadastrar.php',
            'dados'    => []
        ]);
    }

    public function editar($id)
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST') {
            $formulario = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);

            $dados = [
                'id_transporte' => $id,
                'descricao'     => strtoupper($formulario['descricao'] ?? '')
            ];

            if ($this->tipoTransporteModel->atualizar($dados)) {
                Sessao::mensagem('tipo_transporte', 'Tipo de transporte atualizado com sucesso!');
                URL::redirecionar('tipos_transportes');
            } else {
                Sessao::mensagem('tipo_transporte', 'Erro ao atualizar tipo de transporte', 'alert alert-danger');
            }
        }

        $tipo_transporte = $this->tipoTransporteModel->lerTipoTransportePorId($id);

        $dados = [
            'tipo_transporte' => $tipo_transporte
        ];

        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/tipos_transportes/editar.php',
            'dados'    => $dados
        ]);
    }

    public function visualizar($id)
    {
        $dados = [
            'tipo_transporte' => $this->tipoTransporteModel->lerTipoTransportePorId($id)
        ];
        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/tipos_transportes/visualizar.php',
            'dados'    => $dados
        ]);
    }

    public function excluir($id)
    {
        if ($this->tipoTransporteModel->remover($id)) {
            Sessao::mensagem('tipo_transporte', 'Tipo de transporte removido com sucesso!');
        } else {
            Sessao::mensagem('tipo_transporte', 'Erro ao remover tipo de transporte', 'alert alert-danger');
        }
        URL::redirecionar('tipos_transportes');
    }
}
